/*

   F_Phx.rexx

 */

SIGNAL ON FAILURE

IF ~Show('L','rexxsupport.library') THEN DO
   IF ~AddLib('rexxsupport.library',0,-30) THEN DO
      Say('Unable to open rexxsupport.library')
      EXIT 10
   END
END

PARSE ARG src force quiet .

IF Exists(src) THEN DO
   date = Translate(Date(E),'-','/')
   time = Time()

   obj = Left(src,Length(src) - 1) || 'o'

   IF force = 1 THEN DO
      update = 1
   END
   ELSE DO
      state_src = StateF(src)
      state_obj = StateF(obj)
      update    = 0

      IF Word(state_src,5) ~= Word(state_obj,5) THEN update = 1
      IF Word(state_src,6) ~= Word(state_obj,6) THEN update = 1
      IF Word(state_src,7) ~= Word(state_obj,7) THEN update = 1
   END

   IF quiet = 0 THEN DO
      IF update = 1 THEN Say('[1mUpdating [0m' || src || '...')
      ELSE               Say(src || ' [3mok[0m')
   END

   IF update THEN DO
      ADDRESS COMMAND 'PhxAss QUIET' src

      ADDRESS COMMAND 'SetDate FILE' src 'DATE' date 'TIME' time
      ADDRESS COMMAND 'SetDate FILE' obj 'DATE' date 'TIME' time
   END
END
ELSE DO
   Say('File "' || src || '" does not exists')
END
