#include "Private.h"

/*** Private ***************************************************************/

///Label_
FObject Label_(STRPTR Name)
{
   return   TextObject,
            FA_SetMax,           TRUE,
            FA_ChainToCycle,     FALSE,
            FA_Text,             Name,
//                   FA_Text_PreParse,   "FP_Label_PreParse",
            End;
}
//+
///VLabel_
FObject VLabel_(STRPTR Name)
{
   return   TextObject,
            FA_SetMax,        FV_SetMaxH,
            FA_ChainToCycle,  FALSE,
            FA_Text,          Name,
            FA_Text_HCenter,  TRUE,
//                   FA_Text_PreParse,   "FP_Label_PreParse",
            End;
}
//+

/*** Methods ***************************************************************/

///p_Decorator_New
F_METHOD(ULONG,p_Decorator_New)
{
   struct p_LocalObjectData *LOD = F_LOD(Class,Obj);

   return F_SuperDo(Class,Obj,Method,

      FA_ChainToCycle,     FALSE,
      FA_Group_Title,      "Decorator",

      Child, HGroup,
         Child, ColGroup(2), GroupFrame, FA_Frame_Title, "Active",
            Child, Label_("PreParse"), Child, LOD -> g_aprep   = String(NULL,256),
            Child, Label_("Scheme"),   Child, LOD -> g_ascheme = F_NewObj("PopScheme",TAG_DONE),
         End,

         Child, ColGroup(2), GroupFrame, FA_Frame_Title, "Inactive",
            Child, Label_("PreParse"), Child, LOD -> g_iprep   = String(NULL,256),
            Child, Label_("Scheme"),   Child, LOD -> g_ischeme = F_NewObj("PopScheme",TAG_DONE),
         End,
      End,

      Child, ColGroup(2),
         Child, Label_("Class"),    Child, LOD -> g_class = String(NULL,32),
         Child, Label_("Font"),     Child, LOD -> g_font  = String(NULL,32),
      End,

   TAG_MORE,Msg);
}
//+
///p_Decorator_Load
F_METHODM(void,p_Decorator_Load,FS_PreferenceGroup_Load)
{
   struct p_LocalObjectData *LOD = F_LOD(Class,Obj);

   ULONG    data,
            idStr = F_DynamicFindID("FA_String_Contents"),
            idShm = F_DynamicFindID("FA_PopScheme_Spec");

   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_Class",     DEF_DECORATOR_CLASS);      F_Set(LOD -> g_class,   idStr,data);
   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_Font",      DEF_DECORATOR_FONT);       F_Set(LOD -> g_font,    idStr,data);
   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_APreParse", DEF_DECORATOR_APREPARSE);  F_Set(LOD -> g_aprep,   idStr,data);
   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_IPreParse", DEF_DECORATOR_IPREPARSE);  F_Set(LOD -> g_iprep,   idStr,data);
   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_AScheme",   DEF_DECORATOR_ASCHEME);    F_Set(LOD -> g_ascheme, idShm,data);
   data = F_Do(Msg -> Prefs,Msg -> id_Resolve,"FP_Decorator_IScheme",   DEF_DECORATOR_ISCHEME);    F_Set(LOD -> g_ischeme, idShm,data);
}
//+
///p_Decorator_Save
F_METHODM(void,p_Decorator_Save,FS_PreferenceGroup_Save)
{
   struct p_LocalObjectData *LOD = F_LOD(Class,Obj);

   ULONG       data,
               idStr = F_DynamicFindID("FA_String_Contents"),
               idShm = F_DynamicFindID("FA_PopScheme_Spec");

   data = F_Get(LOD -> g_class,     idStr); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_Class",      data);
   data = F_Get(LOD -> g_font,      idStr); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_Font",       data);
   data = F_Get(LOD -> g_aprep,     idStr); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_APreParse",  data);
   data = F_Get(LOD -> g_iprep,     idStr); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_IPreParse",  data);
   data = F_Get(LOD -> g_ascheme,   idShm); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_AScheme",    data);
   data = F_Get(LOD -> g_ischeme,   idShm); F_Do(Msg -> Prefs,Msg -> id_AddString, "FP_Decorator_IScheme",    data);
}
//+

