#include "Private.h"

/*** Hooks *****************************************************************/

struct FS_Message_Open                          { struct FeelinClass *Class; };
struct FS_Message_Close                         { struct FeelinClass *Class; ULONG Ok; };

///Hook_Update
F_HOOKM(void,Hook_Update,FS_Message_Close)
{
   struct FeelinClass     *Class = Msg -> Class;
   struct LocalObjectData *LOD   = F_LOD(Class,Obj);

   if (Msg -> Ok)
   {
      STRPTR spec;

      spec = (STRPTR) F_Get(LOD -> AdjustColor,(ULONG) "FA_AdjustColor_Spec");

      F_Set(Obj,F_IDA(FA_PopColor_Spec),(ULONG)(spec));
   }
   F_DisposeObj(LOD -> Window);

   LOD -> Window = NULL;
   LOD -> AdjustColor = NULL;
}
//+
///Hook_Close
F_HOOKM(void,Hook_Close,FS_Message_Close)
{
   struct LocalObjectData *LOD = F_LOD(Msg -> Class,Obj);

   F_Set(LOD -> Window,FA_Window_Open,FALSE);
   F_Do(_app,FM_Application_PushMethod,Obj,FM_CallHookEntry,3,Hook_Update,Msg -> Class,Msg -> Ok);
}
//+
///Hook_Open
F_HOOKM(void,Hook_Open,FS_Message_Open)
{
   struct FeelinClass     *Class = Msg -> Class;
   struct LocalObjectData *LOD = F_LOD(Class,Obj);

   if (!LOD -> Window)
   {
      FObject gad_ok,gad_cancel;

      if (LOD -> Window =

         WindowObject,
            FA_Window_Title,     F_CAT(ADJUST_COLOR),
            FA_Window_Open,      TRUE,

            Child, VGroup,
               Child, LOD -> AdjustColor = F_NewObj(FC_AdjustColor,"FA_AdjustColor_Spec",F_Get(Obj,F_IDR(FA_PreviewColor_Spec)),TAG_DONE),

               Child, Bar,

               Child, HGroup,
                  Child, gad_ok     = SimpleButton(F_CAT(OK)),
                  Child, gad_cancel = SimpleButton(F_CAT(CANCEL)),
               End,
            End,
         End)
      {
         F_Do(_app,FM_AddMember,LOD -> Window,FV_AddMember_Tail);

         F_Do(gad_ok,FM_Notify,FA_Pressed,FALSE,Obj,FM_CallHookEntry,3,Hook_Close,Class,TRUE);
         F_Do(gad_cancel,FM_Notify,FA_Pressed,FALSE,Obj,FM_CallHookEntry,3,Hook_Close,Class,FALSE);
         F_Do(LOD -> Window,FM_Notify,FA_Window_CloseRequest,TRUE,Obj,FM_CallHookEntry,3,Hook_Close,Class,FALSE);
      }
   }
   else
   {
      F_Do(LOD -> Window,FA_Window_Open,TRUE);
   }
}
//+

/*** Methods ***************************************************************/

///PopColor_New
F_METHOD(APTR,PopColor_New)
{
   struct LocalObjectData *LOD = F_LOD(Class,Obj);

   LOD -> AreaData = (FAreaData *) F_Get(Obj,FA_AreaData);

   if (F_SuperDo(Class,Obj,Method,

      FA_Frame,        "FP_Button_Frame",
      FA_InputMode,     FV_InputMode_Release,
      FA_Draggable,     TRUE,
      FA_Dropable,      TRUE,
      FA_ContextHelp,   F_CAT(HELP),

      TAG_MORE,Msg))
   {
      F_Do(Obj,FM_Notify,FA_Pressed,FALSE,Obj,FM_CallHookEntry,2,Hook_Open,Class);

      return Obj;
   }
   return NULL;
}
//+
///PopColor_Get
F_METHOD(void,PopColor_Get)
{
   struct TagItem *Tags = Msg,item;

   BOOL up=FALSE;

   while  (F_DynamicNTI(&Tags,&item,Class))
   switch (item.ti_Tag)
   {
      case FA_PopColor_Spec:
      {
         F_STORE(F_Get(Obj,F_IDR(FA_PreviewColor_Spec)));
      }
      break;

      default: up = TRUE;
   }

   if (up) F_SUPERDO();
}
//+
///PopColor_Set
F_METHOD(void,PopColor_Set)
{
   struct TagItem         *Tags = Msg,item;

   while  (F_DynamicNTI(&Tags,&item,Class))
   switch (item.ti_Tag)
   {
      case FA_PopColor_Spec:
      {
         F_Set(Obj,F_IDR(FA_PreviewColor_Spec),item.ti_Data);
      }
      break;
   }

   F_SUPERDO();
}
//+

///PopColor_DnDDrop
F_METHODM(void,PopColor_DnDDrop,FS_DnDDrop)
{
   ULONG spec;

   spec = F_Get(Msg -> Source,F_IDR(FA_PreviewColor_Spec));
   if (!spec) spec = F_Get(Msg -> Source,F_IDO(FA_Image_Spec));

   if (spec)
   {
      F_Set(Obj,F_IDA(FA_PopColor_Spec),spec);
   }
}
//+

