;/*

   F_Create.rexx EXE F_Allocs
   QUIT
   _________________________________________________________________________

   F_Alloc 1.00 (2003/02/10)

   Written by Olivier LAVIALE (HaploLaMain@aol.com)

   This tool is for debuggin purpose only !! It will travel trough pools and
   puddles to print every memory allocation done by F_New() or F_NewP().

*/

#include <exec/execbase.h>
#include "Feelin:LIBS/Private.h"

#include <proto/exec.h>
#include <proto/dos.h>

#undef SysBase
extern struct ExecBase             *SysBase;
struct in_FeelinBase               *FeelinBase;

void main(void)
{
   struct FeelinPool      *pool;
   struct FeelinPuddle    *puddle;
   struct FeelinMemChunk  *chunk;
   ULONG                   s1,s2,s3,n1=0,n2=0,n3=0,f=0,
                           args[] = { FALSE, 0};
   APTR                    rdargs;

   if (FeelinBase = (APTR) FindName(&SysBase -> LibList,"feelin.library"))
   {
      if (rdargs = ReadArgs("T=TREE/S",(LONG *)(&args),NULL))
      {
         FreeArgs(rdargs);
      }

      Printf("[2m[41m                                              [0m\n");
      Printf("[2m[41m !! This tool is for debuggin purpose only !! [0m\n");
      Printf("[2m[41m                                              [0m\n\n");

      if (args[0] == FALSE)
      {
         Printf("(Use 'T' or 'TREE' switch for more informations)\n\n");
      }

      s1   = 0;

      for (pool = (APTR)(FeelinBase -> Pools.Head) ; pool ; pool = pool -> Next)
      {
         if (args[0]) Printf("[33mPool[0m 0x%08.lx %s",pool,(pool -> Semaphore.ss_Link.ln_Name) ? pool -> Semaphore.ss_Link.ln_Name : "Private");

         s2 = 0;

         if (puddle = (APTR)(pool -> Puddles.Head))
         {
            if (args[0]) Printf("\n");

            for ( ; puddle ; puddle = puddle -> Next)
            {
               if (args[0]) Printf("   [33mPuddle[0m 0x%08.lx - [1mSize[0m %ld\n",puddle,puddle -> Size - sizeof (struct FeelinPuddle));

               s3 = 0;

               for (chunk = puddle -> First ; chunk ; chunk = chunk -> Next)
               {
                  if (args[0]) Printf("      [33mChunk[0m 0x%08.lx (0x%08.lx) - Next 0x%08.lx - Size %ld\n",chunk,(ULONG)(chunk) + sizeof (struct FeelinMemChunk),chunk -> Next,chunk -> Size);

                  n3++; s3 += chunk -> Size;

                  if (SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
                  {
                     Printf("*** Break\n"); return;
                  }
               }

               if (args[0]) Printf("   [1mUsed[0m %ld - [1mFree[0m %ld\n",s3,puddle -> Free);

               n2++; s2 += s3; f += puddle -> Free;
            }
            if (args[0]) Printf("[1mUsed[0m %ld\n\n",s2);
         }
         else
         {
            if (args[0]) Printf(" is empty\n");
         }

         n1++; s1 += s2;
      }

      if (args[0]) Printf("\n");

      Printf("[1mUsed[0m %ld bytes, [1mFree[0m %ld bytes, [1mTotal[0m %ld bytes. %ld [1mPools[0m, %ld [1mPuddles[0m and %ld [1mChunks[0m.\n",s1,f,s1+f,n1,n2,n3);
   }
   else
   {
      Printf("Feelin is not running.\n");
   }
}
