;/*
   F_Create.rexx EXE F_Classes
   QUIT
   _________________________________________________________________________

   F_Classes 1.00 (2003/02/10)

   Written by Olivier LAVIALE (HaploLaMain@aol.com)

   This tool is for debuggin purpose only  !!  It  will  print  all  classes
   currently available in memory.
*/

#include <exec/execbase.h>
#include "Feelin:LIBS/Private.h"

#include <proto/exec.h>
#include <proto/dos.h>

#undef SysBase
extern struct ExecBase             *SysBase;
struct in_FeelinBase               *FeelinBase;

struct MyArgs
{
   LONG                             ShowMethods;
   LONG                             dummy;
};

void main(void)
{
   if (FeelinBase = (APTR) FindName(&SysBase -> LibList,"feelin.library"))
   {
      struct MyArgs           args[] = { FALSE, 0};
      APTR                    rdargs;

      if (rdargs = ReadArgs("M=METHODS/S",(LONG *)(&args),NULL))
      {
         struct in_FeelinClass *Class;
         ULONG nc=0,nl=0,nd=0;

         F_OPool(FeelinBase -> ClassesPool);

         for (Class = (struct in_FeelinClass *)(FeelinBase -> Classes.Head) ; Class ; Class = (struct in_FeelinClass *)(Class -> Public.Next))
         {
            nc++;

            Printf("(0x%08lx) %-18.s ",Class,Class -> Public.Name);
            if (Class -> DynamicID) {    Printf("(%06lx)",Class -> DynamicID); nd++; }
            else                         Printf("(static)");
            Printf(" [1mUsed[0m %4ld - [1mSize[0m %4ld",Class -> Public.UserCount,Class -> Public.LODSize);
            if (Class -> Module)       { Printf(" - [1mBase[0m 0x%08lx",Class -> Module); nl++; }
            else                         Printf("                  ");
            if (Class -> Public.Super)   Printf(" - [1mSuper[0m %s",Class -> Public.Super -> Name);
            Printf("\n");

            if (SetSignal(0L,SIGBREAKF_CTRL_C) & SIGBREAKF_CTRL_C)
            {
               Printf("*** Break\n"); break;
            }

            if (args -> ShowMethods)
            {
               struct FeelinMethodEntry *entry = Class -> MethodsTable;

               if (entry)
               {
                  for ( ; entry -> Method ; entry++)
                  {
                     Printf("   >> Method 0x%08lx (0x%08lx)",entry -> ID,entry -> Method);
                     if (entry -> Name)
                     Printf(" - %s",entry -> Name);
                     Printf("\n");
                  }
               }
               else
               {
                  Printf("   >> No Methods Table\n");
               }
            }
         }

         Printf("\nTOTAL: %ld [1mClasses[0m - %ld [1mDynamic[0m (%ld Static) - %ld [1mExternal[0m (%ld Builtin)\n",nc,nd,nc - nd,nl,nc - nl);

         F_RPool(FeelinBase -> ClassesPool);

         FreeArgs(rdargs);
      }
      else
      {
         PrintFault(IoErr(),NULL);
      }
   }
   else
   {
      Printf("Feelin is not running.\n");
   }
}
